#include <stdio.h>
#include "types.h"


UINT8 *buf_in, *buf_out;


UINT32 buf_ptr, buf_size;
UINT32 bits_data, bits_size;


void reset_file( UINT8 *buf, UINT32 size )
{
	buf_in = buf;
	buf_ptr = 0;
	buf_size = size;

	bits_data = 0;
	bits_size = 0;
}


void flush_bits()
{
	bits_size = 0;
}


UINT32 get_bits_left( UINT32 total_bits )
{
	UINT32 data, num_bits;
	UINT8 bits_mask[9] = {
		0x00, 0x01, 0x03, 0x07, 0x0f,
		0x1f, 0x3f, 0x7f, 0xff };


	num_bits = total_bits;
	data = 0;

	while( num_bits > 0 ) {
		UINT32 use_bits;


		// ERROR!
		if( buf_ptr >= buf_size ) return -1;



		// 8-bit buffer
		if( bits_size == 0 ) {
			bits_size = 8;
			bits_data = buf_in[ buf_ptr++ ];
		}


		// consume cached bits
		use_bits = num_bits;
		if( use_bits > 8 ) use_bits = 8;
		if( use_bits > bits_size ) use_bits = bits_size;


		/*
		ex.
		123 || 45678 = full 8
		>> 3 needed

		xxx || 123 || 45 = remain 5
		>> 3 needed
		*/

		// tack on bits
		data <<= use_bits;
		data |= ( bits_data >> (bits_size - use_bits) ) & bits_mask[ use_bits ];




		// update cache data
		num_bits -= use_bits;
		bits_size -= use_bits;
	}

	return data;
}


UINT32 get_bits_right( UINT32 total_bits )
{
	UINT32 data, num_bits;
	UINT8 bits_mask[9] = {
		0x00, 0x01, 0x03, 0x07, 0x0f,
		0x1f, 0x3f, 0x7f, 0xff };


	num_bits = total_bits;
	data = 0;

	while( num_bits > 0 ) {
		UINT32 use_bits;


		// ERROR!
		if( buf_ptr >= buf_size ) return -1;



		// 8-bit buffer
		if( bits_size == 0 ) {
			bits_size = 8;
			bits_data = buf_in[ buf_ptr++ ];
		}


		// consume cached bits
		use_bits = num_bits;
		if( use_bits > 8 ) use_bits = 8;
		if( use_bits > bits_size ) use_bits = bits_size;



		/*
		ex.
		45678 || 123 = full 8
		>> 3 needed

		45 || 123 || xxx = remain 5
		>> 3 needed
		*/

		// add on bits
		data |= ( bits_data & bits_mask[use_bits] ) << ( total_bits - num_bits );


		// update cache buffer
		num_bits -= use_bits;
		bits_size -= use_bits;
		bits_data >>= use_bits;
	}

	return data;
}
