#include "types.h"


UINT8 buffer[0x800000];
UINT32 buf_size, buf_ptr;


FILE *fp, *fp_log, *fp_global;



int track_ofs[256][256];
int track_size[256][256];
int part_list[256];
int part_size;




// special analysis
UINT8 track_gm;
UINT8 track_mt32;
UINT8 track_adlib;

UINT8 chan_gm[16];
UINT8 chan_mt32[16];
UINT8 chan_adlib[16];

UINT8 patch_gm[16][128];
UINT8 patch_mt32[16][128];
UINT8 patch_adlib[16][128];

UINT8 perc_gm[16][128];
UINT8 perc_mt32[16][128];
UINT8 perc_adlib[16][128];

UINT8 map_patch_gm[128];
UINT8 map_patch_mt32[128];

UINT8 map_perc_gm[128];
UINT8 map_perc_mt32[128];




int global_warnings;
int global_notice;

char workingDir[2048];
char fileString[2048];
WIN32_FIND_DATA ffd;
HANDLE hFind = INVALID_HANDLE_VALUE;



extern void Parse_Sierra( int argc, char **argv );
extern void Parse_Prince_Persia( int argc, char **argv );



int main( int argc, char **argv )
{
	if( argc < 2 ) return 0;


	fp_global = fopen( "___diff.txt", "w" );


	GetCurrentDirectory(2048,workingDir);
	strcpy( fileString, workingDir );
	strcat( fileString, "\\*" );



	// Find the first file in the directory.
	hFind = FindFirstFile(fileString, &ffd);

	if (INVALID_HANDLE_VALUE == hFind) return 0;



	// List all the files in the directory with some info about them.
	do
	{
		if (ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
			//_tprintf(TEXT("  %s   <DIR>\n"), ffd.cFileName);
		}
		else {
			//filesize.LowPart = ffd.nFileSizeLow;
			//filesize.HighPart = ffd.nFileSizeHigh;
			//_tprintf(TEXT("  %s   %ld bytes\n"), ffd.cFileName, filesize.QuadPart);

			strcpy( fileString, workingDir );
			strcat( fileString, "\\" );
			strcat( fileString, ffd.cFileName );

			//*************************************************
			//*************************************************
			//*************************************************

			if( strcmp( argv[1], "sierra" ) == 0 )
				Parse_Sierra( argc, argv );

			else if( strcmp( argv[1], "prince_persia" ) == 0 )
				Parse_Prince_Persia( argc, argv );
		}
	} while (FindNextFile(hFind, &ffd) != 0);
 

	FindClose(hFind);




	if( global_warnings ) {
		if( fp_global ) fprintf( fp_global, "Total warnings = %d\n", global_warnings );
	}


	if( fp_global ) fprintf( fp_global, "Total notices = %d\n", global_notice );
	if( fp_global ) fclose( fp_global );

	return 0;
}
