/*
Prince of Persia 1/2


Packed files - raw format
- Mixed Adlib-MT32
- Mixed Tandy-GM
*/



void Prince_Persia_2()
{
	int len;


	// Prince2
	if(0) {}
	else if( strcmp( ffd.cFileName, "MIDISND.DAT" ) == 0 ) {}
	else if( strcmp( ffd.cFileName, "NIS3VC.DAT" ) == 0 ) {}
	else if( strcmp( ffd.cFileName, "NISMIDI.DAT" ) == 0 ) {}
	else if( strcmp( ffd.cFileName, "TANDYSND.DAT" ) == 0 ) {}
	else return;

	//*******************************************
	//*******************************************
	//*******************************************

	int skip_header;


	fprintf( fp_global, "%s\n", ffd.cFileName );
	fprintf( fp_global, "\n" );
	fprintf( fp_global, "\n" );
	fprintf( fp_global, "\n" );



	fp = fopen( fileString, "rb" );
	if( !fp ) {
		return;
	}

	fread( &buffer, 1, 0x400000, fp );
	buf_size = ftell( fp );
	fclose(fp);


	skip_header = 5;

	len = strlen(fileString);



	// sound.003
	strcat( fileString, ".txt\0" );


	fp_log = fopen( fileString, "w" );
	if( !fp_log ) {
		return;
	}

	//**********************************************
	//**********************************************
	//**********************************************

	int warnings;


	buf_ptr = skip_header;
	warnings = 0;


	//*****************************************
	//*****************************************
	//*****************************************

	// loop through data
	int cmd, arg1, arg2, chan;
	bool run_cmd;
	bool play_midi;



	// run through tracks
	while(1) {
		if( buf_ptr >= buf_size ) break;


		memset( chan_gm, 0, sizeof(chan_gm) );
		memset( chan_mt32, 0, sizeof(chan_mt32) );
		memset( chan_adlib, 0, sizeof(chan_adlib) );

		memset( patch_gm, 0, sizeof(patch_gm) );
		memset( patch_mt32, 0, sizeof(patch_mt32) );
		memset( patch_adlib, 0, sizeof(patch_adlib) );

		memset( perc_gm, 0, sizeof(perc_gm) );
		memset( perc_mt32, 0, sizeof(perc_mt32) );
		memset( perc_adlib, 0, sizeof(perc_adlib) );



		if( UMEM8(BUF+3) != 'M' ||
				UMEM8(BUF+4) != 'T' ||
				UMEM8(BUF+5) != 'h' ||
				UMEM8(BUF+6) != 'd' ) break;


		track_gm = 0;
		track_mt32 = 0;
		track_adlib = 0;


		// debug log
		fprintf( fp_log, "%s\n", &UMEM8(BUF+0x1d) );

		fprintf( fp_global, "%s\n", &UMEM8(BUF+0x1d) );
		global_notice++;


		for( int lcv=0; lcv<256; lcv++ ) {
			if( UMEM8(lcv+BUF) == '.' &&
					UMEM8(lcv+BUF+1) == 'g' &&
					UMEM8(lcv+BUF+2) == 'm' &&
					UMEM8(lcv+BUF+3) == 'f' )
			{
				fprintf( fp_log, "- General MIDI\n" ); track_gm = 1;
				break;
			}

			else if(
				UMEM8(lcv+BUF) == '.' &&
				UMEM8(lcv+BUF+1) == 'm' &&
				UMEM8(lcv+BUF+2) == 'f' &&
				UMEM8(lcv+BUF+3) == 'f' )
			{
				fprintf( fp_log, "- Adlib\n" );
				fprintf( fp_log, "- MT-32\n" ); track_mt32 = 1;
				break;
			}
		}
		
		
		// skip misc header
		buf_ptr += 0x19;
		


		fprintf( fp_log, "\n" );
		fprintf( fp_log, "\n" );

		fprintf( fp_global, "\n" );

		//------------------------------------------
		//------------------------------------------
		//------------------------------------------

		run_cmd = false;
		play_midi = true;

		while( play_midi ) {
			int start_ptr;


			if( buf_ptr >= buf_size ) break;

			//------------------------------------------
			//------------------------------------------
			//------------------------------------------

			start_ptr = buf_ptr;


			// header
			fprintf( fp_log, "[%06X]  ", buf_ptr );


			// delay value
			if( UMEM8(BUF) < 0x80 ) {
				fprintf( fp_log, "{%02X} ", UMEM8(BUF) );
				buf_ptr += 1;
			}
			else if( UMEM8(BUF+1) < 0x80 ) {
				fprintf( fp_log, "{%02X} {%02X} ", UMEM8(BUF), UMEM8(BUF+1) );
				buf_ptr += 2;
			}
			else if( UMEM8(BUF+2) < 0x80 ) {
				fprintf( fp_log, "{%02X} {%02X} {%02X} ", UMEM8(BUF), UMEM8(BUF+1), UMEM8(BUF+2) );
				buf_ptr += 3;
			}
			else if( UMEM8(BUF+3) < 0x80 ) {
				fprintf( fp_log, "{%02X} {%02X} {%02X} {%02X} ", UMEM8(BUF), UMEM8(BUF+1), UMEM8(BUF+2), UMEM8(BUF+3) );
				buf_ptr += 4;
			}
			else {
				// Illegal!!
				fprintf( fp_log, "{--} " );
			}



			// new MIDI command
			if( UMEM8(BUF) >= 0x80 ) {
				cmd = UMEM8(BUF);
				buf_ptr++;

				chan = cmd & 0xf;
				run_cmd = false;
			}
			else {
				fprintf( fp_log, " --  " );

				run_cmd = true;
			}


			arg1 = UMEM8(BUF);
			arg2 = UMEM8(BUF+1);


			switch( cmd >> 4 ) {
				case 0x8:
				case 0x9:
				case 0xa:
				case 0xb:
				case 0xe:
					buf_ptr += 2;


					if( run_cmd == false )
						fprintf( fp_log, "[%02X] %02X %02X\n", cmd, arg1, arg2 );
					else
						fprintf( fp_log, "%02X %02X\n", arg1, arg2 );
					break;


				case 0xc:
				case 0xd:
					buf_ptr += 1;


					if( run_cmd == false )
						fprintf( fp_log, "[%02X] %02X\n", cmd, arg1 );
					else
						fprintf( fp_log, "%02X\n", arg1 );
					break;


				case 0xf:
					switch( cmd ) {
						case 0xf0:
							fprintf( fp_log, "[%02X] ", cmd );
							fprintf( fp_global, "Sysex!!!  [%02X] ", cmd );

							while( UMEM8(BUF) != 0xF7 ) {
								fprintf( fp_log, "%02X ", UMEM8(BUF) );
								fprintf( fp_global, "%02X ", UMEM8(BUF) );

								buf_ptr++;
							}

							fprintf( fp_log, "%02X\n", UMEM8(BUF) );
							fprintf( fp_global, "%02X\n", UMEM8(BUF) );
							buf_ptr++;

							warnings++;
							global_notice++;
							break;


						case 0xff:
							switch( arg1 ) {
							case 0x07:
								fprintf( fp_log, "[%02X] [%02X] %02X %02X  (UNK1)\n", cmd, arg1, arg2, UMEM8(BUF+2) );

								buf_ptr += 3;
								break;

							case 0x2f:
								fprintf( fp_log, "[%02X] [%02X]  (STOP)\n", cmd, arg1 );
								buf_ptr += 1;

								cmd = 0x00;
								play_midi = false;
								break;

							case 0x51:
								fprintf( fp_log, "[%02X] [%02X] %02X %02X  (UNK3)\n", cmd, arg1, arg2, UMEM8(BUF+2) );

								// arg1 + arg2 (size)
								buf_ptr += 2;
								buf_ptr += arg2;
								break;

							default:
								{
									fprintf( fp_log, "[%02X] [%02X] %02X %02X  (UNK-*)\n", cmd, arg1, arg2, UMEM8(BUF+2) );

									// arg1 + arg2 (size)
									buf_ptr += 2;
									buf_ptr += arg2;
								}
								break;
							}
							break;


						default:
							if( run_cmd == false )
								fprintf( fp_log, "[%02X]  (Unknown)\n", cmd );
							else
								fprintf( fp_log, "%02X\n", arg1 );
							break;
					}
					break;


				default:
					buf_ptr++;
					warnings++;
					global_notice++;


					if( run_cmd == false ) {
						fprintf( fp_log, "%02X = (Unknown)  (WARN!)\n", cmd );
						fprintf( fp_global, "%02X = (Unknown)  (WARN!)\n", cmd );
					}
					else
						fprintf( fp_log, "%02X  (WARN!)\n", arg1 );
						fprintf( fp_global, "%02X  (WARN!)\n", arg1 );
					break;
			}

			//------------------------------------------
			//------------------------------------------
			//------------------------------------------

			// look for soundtrack quirks

			if( (track_gm || track_mt32) ) {
				if( (cmd >> 4) == 0x9 && arg2 > 0 ) {
					if( track_gm ) chan_gm[ chan ] = 1;
					if( track_mt32 ) chan_mt32[ chan ] = 1;
				}

				if( (cmd >> 4) == 0xc ) {
					if( chan != 10-1 ) {
						if( track_gm ) patch_gm[ chan ][ arg1 ] = 1;
						if( track_mt32 ) patch_mt32[ chan ][ arg1 ] = 1;
					}
					else {
						if( track_gm ) perc_gm[ chan ][ arg1 ] = 1;
						if( track_mt32 ) perc_mt32[ chan ][ arg1 ] = 1;
					}
				}


				if( (cmd >> 4) == 0xd && arg1 > 0 ) {
					fprintf( fp_global, "[%06X]  Channel aftertouch = %02X %02X\n", start_ptr, cmd, arg1 );
					global_notice++;
				}


				if( (cmd >> 4) == 0xa && arg2 > 0 ) {
					fprintf( fp_global, "[%06X]  Polyphonic aftertouch = %02X %02X %02X\n", start_ptr, cmd, arg1, arg2 );
					global_notice++;
				}


				if( cmd == 0xc9 && arg1 > 0 ) {
					fprintf( fp_global, "[%06X]  *** Drum kit = %02X %02X\n", start_ptr, cmd, arg1 );
					global_notice++;
				}


				if( cmd == 0x99 && arg2 > 0 ) {
					bool hit = false;
					bool hit2 = false;
					bool hit3 = false;


					// notes = 0-127
					if( arg1 == 27 ) hit = true;
					if( arg1 == 28 ) hit = true;
					if( arg1 == 29 ) hit = true;
					if( arg1 == 30 ) hit = true;
					if( arg1 == 31 ) hit = true;
					if( arg1 == 32 ) hit = true;
					if( arg1 == 33 ) hit = true;
					if( arg1 == 34 ) hit = true;

					if( arg1 == 82 ) hit = true;
					if( arg1 == 83 ) hit = true;
					if( arg1 == 84 ) hit = true;
					if( arg1 == 85 ) hit = true;
					if( arg1 == 86 ) hit = true;
					if( arg1 == 87 ) hit = true;


					// CM32L only (outside of GM + GS)
					if( arg1 >= 88 && arg1 <= 108 ) hit2 = true;


					// Unknown area
					if( track_mt32 || track_gm ) {
						if( arg1 < 27 || arg1 > 108 ) hit3 = true;
					}


					if( hit ) fprintf( fp_global, "[%06X]  (GS) Percussion = %02X %02X %02X\n", start_ptr, cmd, arg1, arg2 );
					if( hit2 ) fprintf( fp_global, "[%06X]  (CM32L) Percussion = %02X %02X %02X\n", start_ptr, cmd, arg1, arg2 );
					if( hit3 ) fprintf( fp_global, "[%06X]  (UNK) Percussion = %02X %02X %02X\n", start_ptr, cmd, arg1, arg2 );


					if( hit ) global_notice++;
					if( hit2 ) global_notice++;
					if( hit3 ) global_notice++;
				}


				if( (cmd>>4) == 0xb ) {
					bool hit = true;


					// log modulation
					if( arg1 == 0x07 ) hit = false;
					if( arg1 == 0x0a ) hit = false;
					if( arg1 == 0x40 ) hit = false;
					if( arg1 == 0x7b ) hit = false;


					if( hit && fp_global ) {
						fprintf( fp_global, "[%06X]  Control change = %02X %02X %02X\n", start_ptr, cmd, arg1, arg2 );

						global_notice++;
					}
				}
			}
		} // end play midi


		fprintf( fp_log, "\n" );
		fprintf( fp_log, "\n" );
		fprintf( fp_log, "\n" );

	
		//************************************************
		//************************************************
		//************************************************

		// look for soundtrack quirks


		bool header;


		header = false;
		for( lcv=0; lcv<16; lcv++ ) {
			if( chan_mt32[lcv] == 1 && (lcv==1-1 || lcv>=11-1) ) {
				if( header == false ) {
					fprintf( fp_global, "*** MT-32 = " );

					header = true;
				}


				fprintf( fp_global, "ch%d (@@@) ", lcv+1 );
				global_notice++;
			}
		}

		if( header == true ) fprintf( fp_global, "\n" );

		//------------------------------------------
		//------------------------------------------
		//------------------------------------------

		global_warnings += warnings;


		fprintf( fp_global, "\n" );
	}


	if( warnings ) fprintf( fp_log, "Warnings = %d", warnings );

	fclose(fp_log);
}
