/*
Adaptive LZW (expands dictionary)



Thanks to: ScummVM + NewRisingSun
*/

#include <memory.h>
#include "types.h"



void Dynamix_RLE_reset()
{
}


void Dynamix_RLE_decode( UINT32 len, UINT8 *buf_out )
{
	UINT32 out_ptr;


	Dynamix_RLE_reset();


	out_ptr = 0;
	while( out_ptr < len )
	{
		UINT32 code;


		// get next code
		code = get_bits_right(8);
		if( code == 0xffffffff ) return;


		// RLE run
		if( code & 0x80 ) {
			UINT32 run;
			UINT8 rle;

			run = code & 0x7f;
			rle = get_bits_right(8);

			for( UINT32 lcv = 0; lcv < run; lcv++ )
				buf_out[ out_ptr++ ] = rle;
		}

		// raw run
		else {
			UINT32 run;
			UINT8 data;

			run = code & 0x7f;

			for( UINT32 lcv = 0; lcv < run; lcv++ ) {
				data = get_bits_right(8);
				
				buf_out[ out_ptr++ ] = data;
			}
		}
	} // end len
}
