#include "types.h"


#include <stdio.h>
#include <string.h>


UINT8 data_in[16 * 0x100000];
UINT8 data_out[16 * 0x100000];


static UINT32 out_val, out_bits;
UINT32 in_size, out_size;


void reset_file_bits()
{
	out_val = 0;
	out_bits = 0;
	out_size = 0;
}


void pack_bits_left( int bits, int val )
{
	while( bits-- ) {
		if( out_bits == 8 ) {
			out_bits = 0;

			data_out[ out_size++ ] = out_val & 0xff;
		}


		out_val <<= 1;
		out_val |= ((val >> bits) & 1);

		out_bits++;
	}
}


void pack_bits_right( int bits, int val )
{
	while( bits-- ) {
		if( out_bits == 8 ) {
			out_bits = 0;

			data_out[ out_size++ ] = out_val & 0xff;
		}


		out_val >>= 1;
		out_val |= (val & 1) << 7;

		val >>= 1;
		out_bits++;
	}
}


void flush_bits_left()
{
	while( out_bits > 0 ) {
		if( out_bits == 8 ) {
			out_bits = 0;

			data_out[ out_size++ ] = out_val & 0xff;
			break;
		}


		out_val <<= 1;
		out_val |= 0;

		out_bits++;
	}
}


void flush_bits_right()
{
	while( out_bits > 0 ) {
		if( out_bits == 8 ) {
			out_bits = 0;

			data_out[ out_size++ ] = out_val & 0xff;
			break;
		}


		out_val >>= 1;
		out_val |= 0;

		out_bits++;
	}
}
