/*****************************************************************************************

PKWDCL unpacker, part of VAG's SCI Tools - Implementation of PKWare's DCL decompression
Copyright (C) 2002  VAG

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Any your applications which uses any part of this source(s) SHOULD BE also
distributed with FREELY AVAILABLE source code. Also, you should include my
name in the source and binary file(s) of your application.
Please, do not remove this banner, it must be included in any source based
on this one. Thanks.

Feel free to contact with author at vagsoft@mail.ru

*****************************************************************************************/

typedef struct _NODE {
   unsigned long path;		//binary path
   char  len;				//number of bits in path
   unsigned short value;	//tree value at this path
} NODE, *PNODE;

NODE literals[]={
{0xf   , 4,0x20},{0x17  , 5,0x45},{0x7   , 5,0x61},{0x1b  , 5,0x65},{0xb   , 5,0x69},{0x13  , 5,0x6c},{0x3   , 5,0x6e},{0x1d  , 5,0x6f},
{0xd   , 5,0x72},{0x15  , 5,0x73},{0x5   , 5,0x74},{0x19  , 5,0x75},{0x29  , 6,0x2d},{0x9   , 6,0x31},{0x31  , 6,0x41},{0x11  , 6,0x43},
{0x21  , 6,0x44},{0x1   , 6,0x49},{0x3e  , 6,0x4c},{0x1e  , 6,0x4e},{0x2e  , 6,0x4f},{0xe   , 6,0x52},{0x36  , 6,0x53},{0x16  , 6,0x54},
{0x26  , 6,0x62},{0x6   , 6,0x63},{0x3a  , 6,0x64},{0x1a  , 6,0x66},{0x2a  , 6,0x67},{0xa   , 6,0x68},{0x32  , 6,0x6d},{0x12  , 6,0x70},
{0x62  , 7,0x0a},{0x22  , 7,0x0d},{0x42  , 7,0x28},{0x2   , 7,0x29},{0x7c  , 7,0x2c},{0x3c  , 7,0x2e},{0x5c  , 7,0x30},{0x1c  , 7,0x32},
{0x6c  , 7,0x33},{0x2c  , 7,0x34},{0x4c  , 7,0x35},{0xc   , 7,0x37},{0x74  , 7,0x38},{0x34  , 7,0x3d},{0x54  , 7,0x42},{0x14  , 7,0x46},
{0x64  , 7,0x4d},{0x24  , 7,0x50},{0x44  , 7,0x55},{0x4   , 7,0x6b},{0x78  , 7,0x77},{0xb8  , 8,0x09},{0x38  , 8,0x22},{0xd8  , 8,0x27},
{0x58  , 8,0x2a},{0x98  , 8,0x2f},{0x18  , 8,0x36},{0xe8  , 8,0x39},{0x68  , 8,0x3a},{0xa8  , 8,0x47},{0x28  , 8,0x48},{0xc8  , 8,0x57},
{0x48  , 8,0x5b},{0x88  , 8,0x5f},{0x8   , 8,0x76},{0xf0  , 8,0x78},{0x70  , 8,0x79},{0x1b0 , 9,0x2b},{0xb0  , 9,0x3e},{0x130 , 9,0x4b},
{0x30  , 9,0x56},{0x1d0 , 9,0x58},{0xd0  , 9,0x59},{0x150 , 9,0x5d},{0x250 ,10,0x21},{0x50  ,10,0x24},{0x390 ,10,0x26},{0x190 ,10,0x71},
{0x290 ,10,0x7a},{0x490 ,11,0x00},{0x90  ,11,0x3c},{0x710 ,11,0x3f},{0x310 ,11,0x4a},{0x510 ,11,0x51},{0x110 ,11,0x5a},{0x610 ,11,0x5c},
{0x210 ,11,0x6a},{0x410 ,11,0x7b},{0x10  ,11,0x7c},{0xfe0 ,12,0x01},{0x7e0 ,12,0x02},{0xbe0 ,12,0x03},{0x3e0 ,12,0x04},{0xde0 ,12,0x05},
{0x5e0 ,12,0x06},{0x9e0 ,12,0x07},{0x1e0 ,12,0x08},{0xee0 ,12,0x0b},{0x6e0 ,12,0x0c},{0xae0 ,12,0x0e},{0x2e0 ,12,0x0f},{0xce0 ,12,0x10},
{0x4e0 ,12,0x11},{0x8e0 ,12,0x12},{0xe0  ,12,0x13},{0xf60 ,12,0x14},{0x760 ,12,0x15},{0xb60 ,12,0x16},{0x360 ,12,0x17},{0xd60 ,12,0x18},
{0x560 ,12,0x19},{0x960 ,12,0x1b},{0x160 ,12,0x1c},{0xe60 ,12,0x1d},{0x660 ,12,0x1e},{0xa60 ,12,0x1f},{0x260 ,12,0x23},{0xc60 ,12,0x25},
{0x460 ,12,0x3b},{0x860 ,12,0x40},{0x60  ,12,0x5e},{0xfa0 ,12,0x60},{0x7a0 ,12,0x7d},{0xba0 ,12,0x7e},{0x3a0 ,12,0x7f},{0xda0 ,12,0xb0},
{0x5a0 ,12,0xb1},{0x9a0 ,12,0xb2},{0x1a0 ,12,0xb3},{0xea0 ,12,0xb4},{0x6a0 ,12,0xb5},{0xaa0 ,12,0xb6},{0x2a0 ,12,0xb7},{0xca0 ,12,0xb8},
{0x4a0 ,12,0xb9},{0x8a0 ,12,0xba},{0xa0  ,12,0xbb},{0xf20 ,12,0xbc},{0x720 ,12,0xbd},{0xb20 ,12,0xbe},{0x320 ,12,0xbf},{0xd20 ,12,0xc0},
{0x520 ,12,0xc1},{0x920 ,12,0xc2},{0x120 ,12,0xc3},{0xe20 ,12,0xc4},{0x620 ,12,0xc5},{0xa20 ,12,0xc6},{0x220 ,12,0xc7},{0xc20 ,12,0xc8},
{0x420 ,12,0xc9},{0x820 ,12,0xca},{0x20  ,12,0xcb},{0xfc0 ,12,0xcc},{0x7c0 ,12,0xcd},{0xbc0 ,12,0xce},{0x3c0 ,12,0xcf},{0xdc0 ,12,0xd0},
{0x5c0 ,12,0xd1},{0x9c0 ,12,0xd2},{0x1c0 ,12,0xd3},{0xec0 ,12,0xd4},{0x6c0 ,12,0xd5},{0xac0 ,12,0xd6},{0x2c0 ,12,0xd7},{0xcc0 ,12,0xd8},
{0x4c0 ,12,0xd9},{0x8c0 ,12,0xda},{0xc0  ,12,0xdb},{0xf40 ,12,0xdc},{0x740 ,12,0xdd},{0xb40 ,12,0xde},{0x340 ,12,0xdf},{0xd40 ,12,0xe1},
{0x540 ,12,0xe5},{0x940 ,12,0xe9},{0x140 ,12,0xee},{0xe40 ,12,0xf2},{0x640 ,12,0xf3},{0xa40 ,12,0xf4},{0x1240,13,0x1a},{0x240 ,13,0x80},
{0x1c40,13,0x81},{0xc40 ,13,0x82},{0x1440,13,0x83},{0x440 ,13,0x84},{0x1840,13,0x85},{0x840 ,13,0x86},{0x1040,13,0x87},{0x40  ,13,0x88},
{0x1f80,13,0x89},{0xf80 ,13,0x8a},{0x1780,13,0x8b},{0x780 ,13,0x8c},{0x1b80,13,0x8d},{0xb80 ,13,0x8e},{0x1380,13,0x8f},{0x380 ,13,0x90},
{0x1d80,13,0x91},{0xd80 ,13,0x92},{0x1580,13,0x93},{0x580 ,13,0x94},{0x1980,13,0x95},{0x980 ,13,0x96},{0x1180,13,0x97},{0x180 ,13,0x98},
{0x1e80,13,0x99},{0xe80 ,13,0x9a},{0x1680,13,0x9b},{0x680 ,13,0x9c},{0x1a80,13,0x9d},{0xa80 ,13,0x9e},{0x1280,13,0x9f},{0x280 ,13,0xa0},
{0x1c80,13,0xa1},{0xc80 ,13,0xa2},{0x1480,13,0xa3},{0x480 ,13,0xa4},{0x1880,13,0xa5},{0x880 ,13,0xa6},{0x1080,13,0xa7},{0x80  ,13,0xa8},
{0x1f00,13,0xa9},{0xf00 ,13,0xaa},{0x1700,13,0xab},{0x700 ,13,0xac},{0x1b00,13,0xad},{0xb00 ,13,0xae},{0x1300,13,0xaf},{0x300 ,13,0xe0},
{0x1d00,13,0xe2},{0xd00 ,13,0xe3},{0x1500,13,0xe4},{0x500 ,13,0xe6},{0x1900,13,0xe7},{0x900 ,13,0xe8},{0x1100,13,0xea},{0x100 ,13,0xeb},
{0x1e00,13,0xec},{0xe00 ,13,0xed},{0x1600,13,0xef},{0x600 ,13,0xf0},{0x1a00,13,0xf1},{0xa00 ,13,0xf5},{0x1200,13,0xf6},{0x200 ,13,0xf7},
{0x1c00,13,0xf8},{0xc00 ,13,0xf9},{0x1400,13,0xfa},{0x400 ,13,0xfb},{0x1800,13,0xfc},{0x800 ,13,0xfd},{0x1000,13,0xfe},{0x0   ,13,0xff},
{0,-1,0}
};

NODE lengths[]={
{0x3   , 2,(0<<12)+  3},{0x5   , 3,(0<<12)+  2},{0x1   , 3,(0<<12)+  4},{0x6   , 3,(0<<12)+  5},
{0xa   , 4,(0<<12)+  6},{0x2   , 4,(0<<12)+  7},{0xc   , 4,(0<<12)+  8},{0x14  , 5,(0<<12)+  9},
{0x4   , 5,(1<<12)+ 10},{0x18  , 5,(2<<12)+ 12},{0x8   , 5,(3<<12)+ 16},{0x30  , 6,(4<<12)+ 24},
{0x10  , 6,(5<<12)+ 40},{0x20  , 6,(6<<12)+ 72},{0x40  , 7,(7<<12)+136},{0x0   , 7,(8<<12)+264},
{0,-1,0}
};

NODE distances[]={
{0x3   , 2,0x00},{0xd   , 4,0x01},{0x5   , 4,0x02},{0x19  , 5,0x03},{0x9   , 5,0x04},{0x11  , 5,0x05},{0x1   , 5,0x06},{0x3e  , 6,0x07},
{0x1e  , 6,0x08},{0x2e  , 6,0x09},{0xe   , 6,0x0a},{0x36  , 6,0x0b},{0x16  , 6,0x0c},{0x26  , 6,0x0d},{0x6   , 6,0x0e},{0x3a  , 6,0x0f},
{0x1a  , 6,0x10},{0x2a  , 6,0x11},{0xa   , 6,0x12},{0x32  , 6,0x13},{0x12  , 6,0x14},{0x22  , 6,0x15},{0x42  , 7,0x16},{0x2   , 7,0x17},
{0x7c  , 7,0x18},{0x3c  , 7,0x19},{0x5c  , 7,0x1a},{0x1c  , 7,0x1b},{0x6c  , 7,0x1c},{0x2c  , 7,0x1d},{0x4c  , 7,0x1e},{0xc   , 7,0x1f},
{0x74  , 7,0x20},{0x34  , 7,0x21},{0x54  , 7,0x22},{0x14  , 7,0x23},{0x64  , 7,0x24},{0x24  , 7,0x25},{0x44  , 7,0x26},{0x4   , 7,0x27},
{0x78  , 7,0x28},{0x38  , 7,0x29},{0x58  , 7,0x2a},{0x18  , 7,0x2b},{0x68  , 7,0x2c},{0x28  , 7,0x2d},{0x48  , 7,0x2e},{0x8   , 7,0x2f},
{0xf0  , 8,0x30},{0x70  , 8,0x31},{0xb0  , 8,0x32},{0x30  , 8,0x33},{0xd0  , 8,0x34},{0x50  , 8,0x35},{0x90  , 8,0x36},{0x10  , 8,0x37},
{0xe0  , 8,0x38},{0x60  , 8,0x39},{0xa0  , 8,0x3a},{0x20  , 8,0x3b},{0xc0  , 8,0x3c},{0x40  , 8,0x3d},{0x80  , 8,0x3e},{0x0   , 8,0x3f},
{0,-1,0}
};
